import { EffectCallback } from 'react';
export interface PageIntervalOptions {
    /**
     * setInterval 是否激活
     * @default true
     */
    enabled?: boolean;
}
export interface PageInterval {
    /**
     * 设置 setInterval 是否运行
     * @param enabled
     */
    setEnabled: (enabled: boolean) => void;
}
declare const _default: (effect: EffectCallback, ms: number, options?: PageIntervalOptions) => PageInterval;
/**
 * 页面定时器，页面释放时释放
 * @param {function} effect
 * @param {number} ms 毫秒 default RESULTS.GRANTED
 * @param {object} options
 * @param {boolean} options.enabled 是否激活 default true
 * @public
 */
export default _default;
