import { EffectCallback } from 'react';
import { Permission } from 'react-native-permissions';
import { PermissionStatus as PermissionStatus_2 } from 'react-native-permissions';

declare interface AppActiveInterval {
    /**
     * 设置 setInterval 是否运行
     * @param {boolean} enabled
     */
    setEnabled: (enabled: boolean) => void;
}

declare interface AppActiveIntervalOptions {
    /**
     * setInterval 是否启用
     * @default true
     */
    enabled?: boolean;
}

declare interface PageEventEmitterParams {
    /**
     * 订阅事件
     */
    emit: () => void;
}

declare type PageGestureEnabledParams = {
    /**
     * 是否激活
     */
    setEnabled: (enabled: boolean) => void;
};

declare interface PageInterval {
    /**
     * 设置 setInterval 是否运行
     * @param enabled
     */
    setEnabled: (enabled: boolean) => void;
}

declare interface PageIntervalOptions {
    /**
     * setInterval 是否激活
     * @default true
     */
    enabled?: boolean;
}

export declare const permissions: {
    request: (permissions: Permission[], permissionStatus?: "unavailable" | "blocked" | "denied" | "granted" | "limited") => PermissionsRequest;
};

declare type PermissionsParams = {
    state: State;
    request: () => RequestResponse;
};

declare type PermissionsRequest = Promise<void | {
    openSettings: Promise<void>;
}>;

declare type RequestResponse = Promise<void | {
    openSettings: Promise<void>;
}>;

declare type State = boolean | null;

export declare const useAppActiveInterval: (effect: EffectCallback, ms: number, options?: AppActiveIntervalOptions) => AppActiveInterval;

export declare const usePageEventEmitter: (key: string, effect?: EffectCallback | undefined) => PageEventEmitterParams;

export declare const usePageGestureEnabled: (enabled: boolean) => PageGestureEnabledParams;

export declare const usePageInterval: (effect: EffectCallback, ms: number, options?: PageIntervalOptions) => PageInterval;

export declare const usePermissions: (permissions: Permission[], permissionStatus?: PermissionStatus_2) => PermissionsParams;

export { }
